(*
  Programming Xinix;
  Johan terryn 1996;
  Multiplicative linear congruential algorithm : D.H.Lehmer;
  Mathematical details : Park S.K. and Miller K.W. (1998) Random number generators, good ones are hard to find. Communications of the ACM, 31, 1192-1201.;
  Returns a pseudo randomnumber between 0 <  and  <= 1;
  Very fast method.
*)
IMPLEMENTATION MODULE Randoms;

VAR Z: LONGINT;

PROCEDURE Random(): REAL;
CONST a = 16807;
      m = 2147483647;
      q = (m DIV a);
      r = (m MOD a);
VAR g: LONGINT;
BEGIN
  g := a*(Z MOD q) - r*(Z DIV q);
  IF g > 0 THEN
    Z := g
  ELSE
    Z := g + m
 END;
 RETURN FLOAT(Z)/FLOAT(m)
END Random;


PROCEDURE InitSeed(seed: LONGINT);
BEGIN
  Z := seed
END InitSeed;

BEGIN
 Z := 1;
END Randoms.

